﻿using Infragistics.Win.UltraWinToolbars;
using Infragistics.Win;
using System;
using System.Collections.Generic;
using System.Drawing.Drawing2D;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace UltraToolbarsManagerDownArrowDemo
{
    public class ArrowFilter : IUIElementDrawFilter
    {
        private Color color;

        private Size arrowSize = new Size(5, 3);

        public Size ArrowSize
        {
            get { return arrowSize; }
            set { arrowSize = value; }
        }

        public ArrowFilter(Color color)
        {
            // TODO: Complete member initialization
            this.color = color;
        }
        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            Point location = drawParams.Element.Rect.Location;
            drawParams.Element.Rect = new Rectangle(new Point(drawParams.Element.Rect.X, 16), arrowSize);

            Point a = drawParams.Element.Rect.Location; a.Offset(-1, 0);
            Point b = a; b.Offset(arrowSize.Width + 2, 0);
            Point c = a; c.Offset(arrowSize.Width / 2 + 1, arrowSize.Height + 1);

            GraphicsPath path = new GraphicsPath();
            path.StartFigure();
            path.AddLines(new Point[] { a, b, c });
            path.CloseFigure();

            Graphics g = drawParams.Graphics;
            g.FillPath(new SolidBrush(color), path);
            return true;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is ArrowUIElement)
            {
                ArrowUIElement arrow = drawParams.Element as ArrowUIElement;
                var x = arrow.Control;                

                return DrawPhase.BeforeDrawElement;                
            }
                
            return DrawPhase.None;
        }
    }
}
